'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDeleteHandler = exports.createLoadHandler = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultOptions = {
  mapToKey: false,
  withLoading: true,
  idsOnly: false
};

var createLoadHandler = exports.createLoadHandler = function createLoadHandler(resourceType, options) {
  return function (state, _ref) {
    var payload = _ref.payload;

    var _defaultOptions$optio = _extends({}, defaultOptions, options),
        mapToKey = _defaultOptions$optio.mapToKey,
        withLoading = _defaultOptions$optio.withLoading,
        idsOnly = _defaultOptions$optio.idsOnly;

    var nextState = _defineProperty({}, mapToKey || resourceType, (0, _merge2.default)({}, state[resourceType], idsOnly ? (0, _map2.default)(payload.data[resourceType], 'id') : payload.data[resourceType]));

    if (withLoading) {
      var add = mapToKey ? (0, _helpers.capitalizeFirstLetter)(mapToKey) : '';
      nextState['isLoaded' + add] = true;
      nextState['isLoading' + add] = false;
    }

    return state.merge(nextState);
  };
};

var createDeleteHandler = exports.createDeleteHandler = function createDeleteHandler(resourceType, options) {
  return function (state, _ref2) {
    var payload = _ref2.payload;

    var _defaultOptions$optio2 = _extends({}, defaultOptions, options),
        mapToKey = _defaultOptions$optio2.mapToKey;

    var deletedId = (0, _get2.default)(payload, 'deletedId');

    return state.merge(_defineProperty({}, mapToKey || resourceType, (0, _reduce2.default)(state[resourceType], function (result, value, key) {
      if (value.id !== deletedId) {
        return _extends({}, result, _defineProperty({}, key, value));
      }
      return _extends({}, result);
    }, {})));
  };
};